/**
  ******************************************************************************
  * @file    vk6932_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    08-15-2019
  * @brief   This file contains all include files for vk6932_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "vk6932_driver.h"
/* extern variables ----------------------------------------------------------*/
unsigned char write_buf[16];
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : VK6932_delay_nus
* Description    : ʱ50uS
* Input          : dur
* Output         : None
* Return         : None
*******************************************************************************/
void VK6932_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : VK6932_delayms
* Description    : ʱ1ms
* Input          : dur
* Output         : None
* Return         : None
*******************************************************************************/
void VK6932_delayms(unsigned int n)
{
	while(n--)
	{
		VK6932_delay_nus(1000);
	}
}

/*******************************************************************************
* Function Name  : Set_testPara
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void Write1BytetoIC(unsigned char data8)
{
	unsigned char i;
	
	VK6932_DAT_HIGH;
	VK6932_STB_LOW;			//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK6932_SLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK6932_DAT_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK6932_DAT_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK6932_delay_nus(200);
		VK6932_SLK_HIGH;	//ʱӵ
		VK6932_delay_nus(200);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}

/*******************************************************************************
* Function Name  : Read1BytefromIC
* Description    : ʱӵͨMCULEDIC1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char Read1BytefromIC(void)
{
	unsigned char i,k=0;//iѭkʱ

	VK6932_STB_LOW;	//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK6932_SLK_LOW;//ȽCLK
    VK6932_delay_nus(200);
		k=k>>1;
		if(VK6932_DIO_IO==0)
		{
			k=k&0x7f;			//DIOΪ͵ƽkλ塰0λֲ
		}
		else
		{
			k=(k|0x80);//DIOΪߵƽkλá1λֲ
		}
		VK6932_SLK_HIGH;	//ʱӵ
		VK6932_delay_nus(200);
	}//һֽں˳ѭ
	
	return(k);//ض1ֽ	
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK6932_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ
	
	VK6932_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1
	Write1BytetoIC(VK6932_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK6932_STB_HIGH;//ҪSTBá1
	Write1BytetoIC(VK6932_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		Write1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK6932_STB_HIGH;//еʾݺ16BYTE󣬽STBá1	
	Write1BytetoIC(VK6932_DISP_ON|VK6932_PDUTY_14_16);//ʾ
	VK6932_STB_HIGH;//ʾ󽫡STBá1
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
void VK6932_Disp_FixedAddr(unsigned char adress, unsigned char data8)
{;
	VK6932_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1
	Write1BytetoIC(VK6932_WRDTA_FIXEDADDR);
	VK6932_STB_HIGH;
	Write1BytetoIC(VK6932_STARTADDR+adress);//ʾݶӦĵַ
	//ַ󣬡STBΪ0Ҫʾ
	Write1BytetoIC(data8);//֡STB=01BYTEʾ
	VK6932_STB_HIGH;//ʾݺ󽫡STBá1
	Write1BytetoIC(VK6932_DISP_ON|VK6932_PDUTY_14_16);//ʾ
	VK6932_STB_HIGH;//ʾ󽫡STBá1
}
/*******************************************************************************
* Function Name  : Vk6932_Init
* Description    : VK6932ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void Vk6932_Init(void)    
{   
	GPIO_SetMode(VK6932_STB_PORT, VK6932_STB_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK6932_CLK_PORT, VK6932_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK6932_DIO_PORT, VK6932_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK6932_STB_HIGH;
	VK6932_DAT_HIGH;                
	VK6932_SLK_HIGH;  	
}  
/*******************************************************************************
* Function Name  : VK6932_Main
* Description    : VK6932Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK6932_Main(void)
{   
	unsigned char i;
	
	Vk6932_Init();
	 
	for(i=0;i<16;i++)
	{
		write_buf[i]=0x00;
	}
	VK6932_Disp_AutoAdd1Addr(0,write_buf,16);   //ȫ
	VK6932_delayms(1000); 
	while(1)
	{		
			for(i=0;i<16;i++)
			{
					write_buf[i]=0xff;					
			}
			VK6932_Disp_AutoAdd1Addr(0,write_buf,16);   //ȫ		  
			VK6932_delayms(1000); 
//			for(i=0;i<16;i++)
//			{
//				write_buf[i]=0x00;
//			}
//			VK6932_Disp_AutoAdd1Addr(0,write_buf,16);   //ȫ	  
//			VK6932_delayms(300); 
//		
//			VK6932_Disp_FixedAddr(0x09, 0x01);  //led-GRID5 SEG9ù̶ַʽд01	  
//			VK6932_delayms(300); 
//	
//			VK6932_Disp_FixedAddr(0x09, 0x00);  //led-GRID5 SEG9ù̶ַʽд00	  
//			VK6932_delayms(300); 
	}
}  
/************************END OF FILE****/
