/**
  ******************************************************************************
  * @file    vk6932_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    08-15-2019
  * @brief   This file contains definitions for vk6932_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************  
  */
#ifndef __VK6932_DRIVER_H__
#define __VK6932_DRIVER_H__

//ѡõĵƬͺżͷļ
#include "M451Series.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
#define 	VK6932_STB_PIN   BIT1
#define 	VK6932_STB_PORT  PA
#define 	VK6932_STB_IO    PA1

#define 	VK6932_CLK_PIN   BIT0
#define 	VK6932_CLK_PORT  PA
#define 	VK6932_CLK_IO    PA0

#define 	VK6932_DIO_PIN   BIT13
#define 	VK6932_DIO_PORT  PA
#define 	VK6932_DIO_IO    PA13

#define   VK6932_STB_HIGH     VK6932_STB_IO = 1  
#define   VK6932_STB_LOW      VK6932_STB_IO = 0

#define   VK6932_SLK_HIGH     VK6932_CLK_IO = 1  
#define   VK6932_SLK_LOW      VK6932_CLK_IO = 0   
  
#define   VK6932_DAT_HIGH     VK6932_DIO_IO = 1   
#define   VK6932_DAT_LOW      VK6932_DIO_IO = 0 
 

#define   VK6932_STARTADDR		0XC0 

#define   VK6932_WRDTA_AUTOADD1ADDR   	0x40  
#define   VK6932_WRDTA_FIXEDADDR     	  0x44  

#define 	VK6932_DISP_ON        0X88  //ʾ
#define 	VK6932_DISP_OFF		    0x80  //ʾ  
/*0x80, 0x81,  0x82,  0x83,  0x84,  0x85,  0x86,  0x87 ֱӦ
1/16,   2/16,  4/16,  10/16, 11/16, 12/16, 13/16, 14/16  */ 
#define 	VK6932_PDUTY_1_16      0X80  //ʾΪ1/16  
#define 	VK6932_PDUTY_2_16      0X81  //ʾΪ2/16  
#define 	VK6932_PDUTY_4_16      0X82  //ʾΪ4/16  
#define 	VK6932_PDUTY_10_16     0X83  //ʾΪ10/16  
#define 	VK6932_PDUTY_11_16     0X84  //ʾΪ11/16  
#define 	VK6932_PDUTY_12_16     0X85  //ʾΪ12/16  
#define 	VK6932_PDUTY_13_16     0X86  //ʾΪ13/16  
#define 	VK6932_PDUTY_14_16     0X87  //ʾΪ14/16  
 
/* Exported functions ------------------------------------------------------- */
void Vk6932_Init(void);  
void VK6932_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num);
void VK6932_Disp_FixedAddr(unsigned char adress, unsigned char data8);
unsigned char VK6932_KeyScan(void);
void test_vk6932(void);
#endif  /*__VK6932_DRIVER_H__*/

/************************END OF FILE****/
